/*
 * Hedgewars for Android. An Android port of Hedgewars, a free turn based strategy game
 * Copyright (c) 2011-2012 Richard Deurwaarder <xeli@xelification.com>
 * Copyright (C) 2012 Simeon Maxein <smaxein@googlemail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package org.hedgewars.hedgeroid.EngineProtocol;

public class PascalExports {
    public static Object engineMutex = new Object();

    protected final static String[] libs = {
        "SDL2",
        "SDL2_image",
        "mikmod",
        "SDL2_net",
        "SDL2_mixer",
        "SDL2_ttf",
        "lua",
        "physfs",
        "physlayer",
        "hwengine",
    };

    static{
        for (String l : libs) {
            try {
                android.util.Log.d("org.hedgewars.hedgeroid.EngineProtocol.PascalExports", "Hedgewars (class PascalExports) is attempting to load library '" + l + "' ...");
                System.loadLibrary(l);
                android.util.Log.d("org.hedgewars.hedgeroid.EngineProtocol.PascalExports", "Hedgewars (class PascalExports) successfully loaded library '" + l + "'.");
            } catch (Exception ex) {
                android.util.Log.e("org.hedgewars.hedgeroid.EngineProtocol.PascalExports", "Hedgewars (class PascalExports) failed to load library '" + l + "':" + ex.getMessage());
                throw ex;
            }
        }
    }

    public static native int HWgetMaxNumberOfTeams();
    private static native void HWGenLandPreview(int port);

    public static void synchronizedGenLandPreview(int port) {
        synchronized(engineMutex) {
            HWGenLandPreview(port);
        }
    }

}
